-- #######################################
-- #######################################
-- SETTNGS
-- #######################################
-- #######################################

-- GoH Event Registrations
	GoH = {}
	GoH.events = {}

	GoH.eventFrame = CreateFrame("Frame");
	GoH.eventFrame:SetScript("OnEvent", function(self, event, ...) GoH.events[event](...) end);

	-- EVERY EVENT YOU REGISTER MUST HAVE A FUNCTION
	GoH.eventFrame:RegisterEvent("ADDON_LOADED");
	GoH.eventFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
	GoH.eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
	GoH.eventFrame:RegisterEvent("UNIT_COMBAT");
	GoH.eventFrame:RegisterEvent("PLAYER_TARGET_CHANGED");
	GoH.eventFrame:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND");
	GoH.eventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	GoH.eventFrame:RegisterEvent("UNIT_TARGET");
	GoH.eventFrame:RegisterEvent("COMBAT_LOG_EVENT");
	GoH.eventFrame:RegisterEvent("DUEL_REQUESTED");
	GoH.eventFrame:RegisterEvent("DUEL_FINISHED");

-- FILTER 'NOT READY YET' ERROR TEXT AND OTHERS
function GoH_Error_Text_Filter()

	-- GOH FILTER: FILTER OUT ERROR MESSAGE TEXTS
	-- LOOKS LIKE WE CANT ASSIGN OUR OWN BLANK TEXT VALUES... PROTECTED AND GIVES ADDON FORBIDDEN ERRORS
	-- SPELL_FAILED_CANT_CAST_ON_TAPPED = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	ERR_ABILITY_COOLDOWN = ""; -- = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	ERR_CLIENT_LOCKED_OUT = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	ERR_ITEM_COOLDOWN = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	ERR_OUT_OF_RANGE = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	ERR_SPELL_COOLDOWN = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	ERR_SPELL_OUT_OF_RANGE = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	SPELL_FAILED_CASTER_AURASTATE = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	SPELL_FAILED_SPELL_IN_PROGRESS = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;
	SPELL_FAILED_TARGET_AURASTATE = ""; --  = GoHv5_DeathKnight_Data.config.FILTER_ERROR_TEXT;

end


-- INTRO FRAME
function Show_Intro_Frame()

	if GoHv5_DeathKnight_Data.config.ToC_Version == nil then
		GoHv5_DeathKnight_Data.config.ToC_Version = "BLANK";
	end
	if GoHv5_DeathKnight_Data.config.ToC_Version ~= (GetAddOnMetadata("GoH_DeathKnight", "Version")) then

		UIFrameFlash(GoH_IntroFrame, 1, 2, 10, false, 5, 4)
		GoHv5_DeathKnight_Data.config.ToC_Version = GetAddOnMetadata("GoH_DeathKnight", "Version");

	end
end


-- TOASTY FRAME
function Show_Toasty_Frame()
	UIFrameFlash(GoH_ToastyFrame, 1, 2, 3, false, 0, 3)
	PlaySoundFile("Interface\\AddOns\\GoH\\Sounds\\Toasty.mp3","Master");
end
-- RANDOM TOASTY FUNCTION CALL
function Call_RANDOM_Toasty_Frame()

		-- CALL RANDOM MATH GENERATOR
		GoH_DeathKnight.NumberRandom = math.random(100);

		-- USE RANDOM MATH GENERATED RESULT

		if (GoH_DeathKnight.NumberRandom == 1) then

			-- ONE OUT OF A HUNDRED CHANCE TO ACTUALLY SHOW THE TOASTY DEVELOPER GRAPHIC FROM MORTAL KOMBAT
			-- JUST ADDS A BIT OF SPICE, THINK OF IT AS AN EASTER EGG.
			Show_Toasty_Frame();

		elseif (GoH_DeathKnight.NumberRandom ~= 1) then
			-- DO NOTHING
			-- RETURN TO WHAT EVER CALLED YOU HERE.
		end

end


-- FIGHT FRAME
function Show_Fight_Frame()
	UIFrameFlash(GoH_FightFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FightFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FightFrame3, 1, 2, 3, false, 0, 4)
end


-- FINISH HIM FRAME
function Show_Finish_Him_Frame()
	UIFrameFlash(GoH_FinishHimFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FinishHimFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FinishHimFrame3, 1, 2, 3, false, 0, 4)
end
-- FINISH HER FRAME
function Show_Finish_Her_Frame()
	UIFrameFlash(GoH_FinishHerFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FinishHerFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FinishHerFrame3, 1, 2, 3, false, 0, 4)
end
-- FINISH IT FRAME
function Show_Finish_It_Frame()
	UIFrameFlash(GoH_FinishItFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FinishItFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FinishItFrame3, 1, 2, 3, false, 0, 4)
end

-- FADE GOH MENU FRAME IN (JUST MESSING AROUND AND EXPERIMENTING)
function Show_GOH_MENU_Frame()
	UIFrameFlash(GoH_Form, 1, 0, 1, true, 0, 0)
	UIFrameFlash(GoH_Form, 1, 0, 1, true, 0, 0)
	UIFrameFlash(GoH_Form, 1, 0, 1, true, 0, 0)
end
-- FADE GOH MENU FRAME OUT (JUST MESSING AROUND AND EXPERIMENTING)
function Hide_GOH_MENU_Frame()
	UIFrameFlash(GoH_Form, 0, 1, 1, false, 0, 0)
	UIFrameFlash(GoH_Form, 0, 1, 1, false, 0, 0)
	UIFrameFlash(GoH_Form, 0, 1, 1, false, 0, 0)
end

-- UPDATE SCOREBOARD VALUES
function doScoreBoard()
		-- SET SCOREBOARD TEXT
		Settings_SCOREBOARD_ANIMALITY_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Animality);
		Settings_SCOREBOARD_ANNIHILATED_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Annihilated);
		Settings_SCOREBOARD_BABALITY_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Babality);
		Settings_SCOREBOARD_BRUTALITY_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Brutality);
		Settings_SCOREBOARD_EXCELLENT_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Excellent);
		Settings_SCOREBOARD_FABULOUS_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Fabulous);
		Settings_SCOREBOARD_FATALITY_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Fatality);
		Settings_SCOREBOARD_FLAWLESS_VICTORY_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_FlawlessVictory);
		Settings_SCOREBOARD_IMPRESSIVE_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Impressive);
		Settings_SCOREBOARD_OUTSTANDING_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Outstanding);
		Settings_SCOREBOARD_SUPERB_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Superb);
		Settings_SCOREBOARD_WELL_DONE_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_WellDone);
		Settings_SCOREBOARD_WONDERFUL_Text:SetText(GoHv5_DeathKnight_Data.config.ScoreBoard_Wonderful);

end


-- ANIMALITY FRAME
function Show_Animality_Frame()
	UIFrameFlash(GoH_AnimalityFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_AnimalityFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_AnimalityFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Animality = (GoHv5_DeathKnight_Data.config.ScoreBoard_Animality + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- ANNIHILATED FRAME
function Show_Annihilated_Frame()
	UIFrameFlash(GoH_AnnihilatedFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_AnnihilatedFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_AnnihilatedFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Annihilated = (GoHv5_DeathKnight_Data.config.ScoreBoard_Annihilated + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- BABALITY FRAME
function Show_Babality_Frame()
	UIFrameFlash(GoH_BabalityFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_BabalityFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_BabalityFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Babality = (GoHv5_DeathKnight_Data.config.ScoreBoard_Babality + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- BRUTALITY FRAME
function Show_Brutality_Frame()
	UIFrameFlash(GoH_BrutalityFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_BrutalityFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_BrutalityFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Brutality = (GoHv5_DeathKnight_Data.config.ScoreBoard_Brutality + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- EXCELLENT FRAME
function Show_Excellent_Frame()
	UIFrameFlash(GoH_ExcellentFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_ExcellentFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_ExcellentFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Excellent = (GoHv5_DeathKnight_Data.config.ScoreBoard_Excellent + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- FABULOUS FRAME
function Show_Fabulous_Frame()
	UIFrameFlash(GoH_FabulousFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FabulousFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FabulousFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Fabulous = (GoHv5_DeathKnight_Data.config.ScoreBoard_Fabulous + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- FATALITY FRAME
function Show_Fatality_Frame()
	UIFrameFlash(GoH_FatalityFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FatalityFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FatalityFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Fatality = (GoHv5_DeathKnight_Data.config.ScoreBoard_Fatality + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- FLAWLESS VICTORY FRAME
function Show_FlawlessVictory_Frame()
	UIFrameFlash(GoH_FlawlessVictoryFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FlawlessVictoryFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_FlawlessVictoryFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_FlawlessVictory = (GoHv5_DeathKnight_Data.config.ScoreBoard_FlawlessVictory + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- IMPRESSIVE FRAME
function Show_Impressive_Frame()
	UIFrameFlash(GoH_ImpressiveFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_ImpressiveFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_ImpressiveFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Impressive = (GoHv5_DeathKnight_Data.config.ScoreBoard_Impressive + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- OUTSTANDING FRAME
function Show_Outstanding_Frame()
	UIFrameFlash(GoH_OutstandingFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_OutstandingFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_OutstandingFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Outstanding = (GoHv5_DeathKnight_Data.config.ScoreBoard_Outstanding + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- SUPERB FRAME
function Show_Superb_Frame()
	UIFrameFlash(GoH_SuperbFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_SuperbFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_SuperbFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Superb = (GoHv5_DeathKnight_Data.config.ScoreBoard_Superb + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- WELL DONE FRAME
function Show_WellDone_Frame()
	UIFrameFlash(GoH_WellDoneFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_WellDoneFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_WellDoneFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_WellDone = (GoHv5_DeathKnight_Data.config.ScoreBoard_WellDone + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end

-- WONDERFUL FRAME
function Show_Wonderful_Frame()
	UIFrameFlash(GoH_WonderfulFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_WonderfulFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_WonderfulFrame3, 1, 2, 3, false, 0, 4)
	if GoHv5_DeathKnight_Data.config.Fatality_Example == "NO" then
		GoHv5_DeathKnight_Data.config.ScoreBoard_Wonderful = (GoHv5_DeathKnight_Data.config.ScoreBoard_Wonderful + 1);
	end
	GoHv5_DeathKnight_Data.config.Fatality_Example = "NO";
	doScoreBoard();
end


-- YOU LOSE FRAME
function Show_You_Lose_Frame()
	UIFrameFlash(GoH_YouLoseFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_YouLoseFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_YouLoseFrame3, 1, 2, 3, false, 0, 4)
end

-- YOU WIN FRAME
function Show_You_Win_Frame()
	UIFrameFlash(GoH_YouWinFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_YouWinFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_YouWinFrame3, 1, 2, 3, false, 0, 4)
end

-- CRITICAL HIT FRAME
function Show_Critical_Hit_Frame()
	UIFrameFlash(GoH_CriticalHitFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_CriticalHitFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_CriticalHitFrame3, 1, 2, 3, false, 0, 4)
end

-- KILLING BLOW FRAME
function Show_Killing_Blow_Frame()
	UIFrameFlash(GoH_KillingBlowFrame, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_KillingBlowFrame2, 1, 2, 3, false, 0, 4)
	UIFrameFlash(GoH_KillingBlowFrame3, 1, 2, 3, false, 0, 4)
end


function GoH_Spec()

		local currentSpec = GetSpecialization()
		local currentSpecName = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"
		-- print("Your current spec:", currentSpecName)

		GoHv5_DeathKnight_Data.config.Current_Spec = currentSpecName;

    if GoHv5_DeathKnight_Data.config.Show_Minimap_Icon == "NO" then
	-- NO MINIMAP ICON
		GoH_MinimapButton:Hide();
	else
	-- YES MINIMAP ICON
		GoH_MinimapButton:Show();

		if GoHv5_DeathKnight_Data.config.Use_Minimap_Spec_Icon == "YES" then
		-- YES MINIMAP SPEC

			if (currentSpecName == "Blood") or (currentSpecName == "Guardian") or (currentSpecName == "Protection") or (currentSpecName == "Brewmaster") then
				-- TANK ICON
				GoH_MinimapButton_Icon:SetTexture("Interface\\AddOns\\GoH\\GoH_Tank.tga");
			elseif (currentSpecName == "Restoration") or (currentSpecName == "Holy") or (currentSpecName == "Discipline") or (currentSpecName == "Mistweaver") then
				-- HEAL ICON
				GoH_MinimapButton_Icon:SetTexture("Interface\\AddOns\\GoH\\GoH_Healer.tga");
			elseif (currentSpecName == "Frost") or (currentSpecName == "Unholy") or (currentSpecName == "Balance") or (currentSpecName == "Feral") or (currentSpecName == "Beast Mastery") or (currentSpecName == "Marksmanship") or (currentSpecName == "Survival") or (currentSpecName == "Arcane") or (currentSpecName == "Fire") or (currentSpecName == "Frost") or (currentSpecName == "Retribution") or (currentSpecName == "Shadow") or (currentSpecName == "Assassination") or (currentSpecName == "Combat") or (currentSpecName == "Subtlety") or (currentSpecName == "Elemental") or (currentSpecName == "Enhancement") or (currentSpecName == "Affliction") or (currentSpecName == "Demonology") or (currentSpecName == "Destruction") or (currentSpecName == "Arms") or (currentSpecName == "Fury") or (currentSpecName == "MonkDPS") then
				-- DPS ICON
				GoH_MinimapButton_Icon:SetTexture("Interface\\AddOns\\GoH\\GoH_Damager.tga");
			else
				-- STANDARD MK ICON
				GoH_MinimapButton_Icon:SetTexture("Interface\\AddOns\\GoH\\GoH_Icon.tga");
			end

		else
		-- NO MINIMAP SPEC

			-- STANDARD MK ICON
			GoH_MinimapButton_Icon:SetTexture("Interface\\AddOns\\GoH\\GoH_Icon.tga");
		end

	end

end


-- #######################################
-- #######################################
-- LOAD ADDON FUNCTION
-- #######################################
-- #######################################
function GoH.events.ADDON_LOADED(addon)

	if addon ~= "GoH" then
		return;
	end

	-- MAX OUT THE BLOOD LEVEL IF NOT ALREADY MAXED
	-- (Won't take affect until a reload)
	-- DEFAULT LEVEL IS 2
	SetCVar("violencelevel", 5);

	GoH_Form:SetScale(0.9);
	GoH_Form:SetAlpha(0.85);

    -- Slash Options
    SlashCmdList["GoH"] = GoH.Options
        SLASH_GoH1 = "/GoH"
        SLASH_GoH2 = "/goh!"
        SLASH_GoH3 = "/getoverhere!"
        SLASH_GoH4 = "/GetOverHere"
	  SlashCmdList["GoH"] = GoH_Settings_MINIMAP_TOGGLE;

	if GoH_DeathKnight.Faction == "Horde" then
		Settings_FactionPicTexture:SetTexture("interface\\AddOns\\GoH\\Images\\GoH_v5_BackGround_Faction_Horde.tga")
	elseif GoH_DeathKnight.Faction == "Alliance" then
		Settings_FactionPicTexture:SetTexture("interface\\AddOns\\GoH\\Images\\GoH_v5_BackGround_Faction_Alliance.tga")
	elseif GoH_DeathKnight.Faction == "Neutral" then
		Settings_FactionPicTexture:SetTexture("interface\\AddOns\\GoH\\Images\\GoH_v5_BackGround_Faction_Neutral.tga")
	end
	if GoH_DeathKnight.Gender == "Female" then
		Settings_Female_Texture:Show();
	else
		Settings_Female_Texture:Hide();
	end
	GoH_Settings_Set_Menu_Button_Images();

	    if GoHv5_DeathKnight_Data.config.USE_ERROR_TEXT == "YES" then
	    	GoH_Error_Text_Filter();
	    	SetCVar("scriptErrors", nil);
		end

end




function GoH_Check_Whisper_Reply_Message_Text()
	GoHv5_DeathKnight_Data.config.AutoDecline_Whisper_Message = GoH5_EditBox_Whisper_Reply_Message:GetText();
	if GoH5_EditBox_Whisper_Reply_Message:GetText() == "" then
		GoH5_EditBox_Whisper_Reply_Message:SetText("Your request has been automatically declined.");
		GoHv5_DeathKnight_Data.config.AutoDecline_Whisper_Message = GoH5_EditBox_Whisper_Reply_Message:GetText();
	end

	GoHv5_DeathKnight_Data.config.AutoDND_Auction_House_Whisper_Message = GoH5_EditBox_Settings_Auction_House_Reply:GetText();
	if GoH5_EditBox_Settings_Auction_House_Reply:GetText() == "" then
		GoH5_EditBox_Settings_Auction_House_Reply:SetText("I'm busy at the moment, sorry.");
		GoHv5_DeathKnight_Data.config.AutoDND_Auction_House_Whisper_Message = GoH5_EditBox_Settings_Auction_House_Reply:GetText();
	end

	GoHv5_DeathKnight_Data.config.AutoDND_In_Combat_Whisper_Message = GoH5_EditBox_Settings_In_Combat_Reply:GetText();
	if GoH5_EditBox_Settings_In_Combat_Reply:GetText() == "" then
		GoH5_EditBox_Settings_In_Combat_Reply:SetText("I'm in combat at the moment, sorry.");
		GoHv5_DeathKnight_Data.config.AutoDND_In_Combat_Whisper_Message = GoH5_EditBox_Settings_In_Combat_Reply:GetText();
	end

end



-- CLOSE BUTTON
function GoH_BUTTON_CLOSE_OnClick()

	Play_GUI_Close();
	-- Hide_GOH_MENU_Frame();
	GoH_Form:Hide();

end

-- OPEN MENU
function GoH_OPEN_MENU()

	if (GoH_Form:IsVisible()) then
		Play_GUI_Close();
	else
		Play_GUI_Open();
	end


	GoH_Hide_and_Seek();

		-- Get the Version of the Setting's Addon from the TOC file
		-- and display it on the Setting's Menu near the close button.
		GoH_Settings_Addon_Version = GetAddOnMetadata("GoH", "Version");
		Label_GoHv5_Settings_VERSION:SetText("|cFFFFD000GoH Core v"..GoH_Settings_Addon_Version.."|r");

	GoH_Lose_Focus_of_EditBoxes();

end

-- HIDE OTHER MENU FRAMES AND ALIGN THEM TO THE CORRECT USER PLACED LOCATION
function GoH_Hide_and_Seek()

	-- Set Health Background Image
	if GoHv5_DeathKnight_Data.config.Health_Percentage_Value == "25" then
			GoH_Health_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Health_25");
	elseif GoHv5_DeathKnight_Data.config.Health_Percentage_Value == "20" then
			GoH_Health_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Health_20");
	elseif GoHv5_DeathKnight_Data.config.Health_Percentage_Value == "15" then
			GoH_Health_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Health_15");
	elseif GoHv5_DeathKnight_Data.config.Health_Percentage_Value == "10" then
			GoH_Health_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Health_10");
	elseif GoHv5_DeathKnight_Data.config.Health_Percentage_Value == "5" then
			GoH_Health_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Health_5");
	end
	-- Set Mana Background Image
	if GoHv5_DeathKnight_Data.config.Mana_Percentage_Value == "25" then
			GoH_Mana_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Mana_25");
	elseif GoHv5_DeathKnight_Data.config.Mana_Percentage_Value == "20" then
			GoH_Mana_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Mana_20");
	elseif GoHv5_DeathKnight_Data.config.Mana_Percentage_Value == "15" then
			GoH_Mana_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Mana_15");
	elseif GoHv5_DeathKnight_Data.config.Mana_Percentage_Value == "10" then
			GoH_Mana_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Mana_10");
	elseif GoHv5_DeathKnight_Data.config.Mana_Percentage_Value == "5" then
			GoH_Mana_Frame_Texture:SetTexture("interface\\Addons\\GoH\\Images\\GoH_Mana_5");
	end

	-- GOH SETTINGS: Page Tab
	if GoHv5_DeathKnight_Data.config.Settings_Page_Tab == nil then
		GoHv5_DeathKnight_Data.config.Settings_Page_Tab = "ONE";
	end
	if GoHv5_DeathKnight_Data.config.Settings_Page_Tab == "TWO" then
		-- PAGE TWO
		GoH_SETTINGS_PAGE_TAB_TWO_BUTTON_ICON:Disable();
		GoH_Frame:Hide();

		GoH_SETTINGS_PAGE_TAB_ONE_BUTTON_ICON:Enable();
		GoH_Frame_Page2:Show();

	else
		-- PAGE ONE
		GoH_SETTINGS_PAGE_TAB_ONE_BUTTON_ICON:Disable();
		GoH_Frame_Page2:Hide();

		GoH_SETTINGS_PAGE_TAB_TWO_BUTTON_ICON:Enable();
		GoH_Frame:Show();

	end

	GoH_Settings_Set_AutoDecline_Whisper_Reply_Images();
	GoH_Settings_Set_AutoDND_Auction_House_Whisper_Reply_Button_Images();
	GoH_Settings_Set_AutoDND_In_Combat_Whisper_Reply_Button_Images();

	-- ###########################
	-- Disable Menu Button for Menu you are on
	-- ###########################
	GoHv5_Settings_MenuButtonSettings:Disable();

	-- ###########################
	-- Hide all other addon menus and show the one you want
	-- ###########################


	-- #######################################################
	-- Match all other addon menus to the Settings location
	-- #######################################################

	-- Release all points before re-assigning or we'll get a lua error
	if (GoH_DeathKnight_Form:IsVisible()) then
		GoH_DeathKnight_Form:ClearAllPoints();
		GoH_DeathKnight_Form:Hide();
		GoH_Form:ClearAllPoints();
		GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
		-- Show_GOH_MENU_Frame();
		GoH_Form:Show();
	else


			-- CHECK TO SEE IF GoH_Druid IS INSTALLED
			_, _, _, GoH_Druid_enabled, _, _, _ = GetAddOnInfo("GoH_Druid")
			if GoH_Druid_enabled == 1 then
			-- IF GoH_Druid IS INSTALLED
				GoHv5_Settings_MenuButtonDruid:Enable();
				GoHv5_DeathKnight_MenuButtonDruid:Enable();
				if (GoH_Druid_Form:IsVisible()) then
					GoH_Druid_Form:ClearAllPoints();
					GoH_Druid_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Druid_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Druid_Form:ClearAllPoints();
				GoH_Druid_Form:Hide();
			else
			-- IF GoH_Druid IS NOT INSTALLED
				GoHv5_Settings_MenuButtonDruid:Disable();
				GoHv5_DeathKnight_MenuButtonDruid:Disable();
			end

			-- CHECK TO SEE IF GoH_Hunter IS INSTALLED
			_, _, _, GoH_Hunter_enabled, _, _, _ = GetAddOnInfo("GoH_Hunter")
			if GoH_Hunter_enabled == 1 then
			-- IF GoH_Hunter IS INSTALLED
				GoHv5_Settings_MenuButtonHunter:Enable();
				GoHv5_DeathKnight_MenuButtonHunter:Enable();
				if (GoH_Hunter_Form:IsVisible()) then
					GoH_Hunter_Form:ClearAllPoints();
					GoH_Hunter_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Hunter_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Hunter_Form:ClearAllPoints();
				GoH_Hunter_Form:Hide();
			else
			-- IF GoH_Hunter IS NOT INSTALLED
				GoHv5_Settings_MenuButtonHunter:Disable();
				GoHv5_DeathKnight_MenuButtonHunter:Disable();
			end

			-- CHECK TO SEE IF GoH_Mage IS INSTALLED
			_, _, _, GoH_Mage_enabled, _, _, _ = GetAddOnInfo("GoH_Mage")
			if GoH_Mage_enabled == 1 then
			-- IF GoH_Mage IS INSTALLED
				GoHv5_Settings_MenuButtonMage:Enable();
				GoHv5_DeathKnight_MenuButtonMage:Enable();
				if (GoH_Mage_Form:IsVisible()) then
					GoH_Mage_Form:ClearAllPoints();
					GoH_Mage_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Mage_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Mage_Form:ClearAllPoints();
				GoH_Mage_Form:Hide();
			else
			-- IF GoH_Mage IS NOT INSTALLED
				GoHv5_Settings_MenuButtonMage:Disable();
				GoHv5_DeathKnight_MenuButtonMage:Disable();
			end

			-- CHECK TO SEE IF GoH_Monk IS INSTALLED
			_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
			if GoH_Monk_enabled == 1 then
			-- IF GoH_Monk IS INSTALLED
				GoHv5_Settings_MenuButtonMonk:Enable();
				GoHv5_DeathKnight_MenuButtonMonk:Enable();
				if (GoH_Monk_Form:IsVisible()) then
					GoH_Monk_Form:ClearAllPoints();
					GoH_Monk_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Monk_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Monk_Form:ClearAllPoints();
				GoH_Monk_Form:Hide();
			else
			-- IF GoH_Monk IS NOT INSTALLED
				GoHv5_Settings_MenuButtonMonk:Disable();
				GoHv5_DeathKnight_MenuButtonMonk:Disable();
			end

			-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
			_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
			if GoH_Paladin_enabled == 1 then
			-- IF GoH_Paladin IS INSTALLED
				GoHv5_Settings_MenuButtonPaladin:Enable();
				GoHv5_DeathKnight_MenuButtonPaladin:Enable();
				if (GoH_Paladin_Form:IsVisible()) then
					GoH_Paladin_Form:ClearAllPoints();
					GoH_Paladin_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Paladin_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Paladin_Form:ClearAllPoints();
				GoH_Paladin_Form:Hide();
			else
			-- IF GoH_Paladin IS NOT INSTALLED
				GoHv5_Settings_MenuButtonPaladin:Disable();
				GoHv5_DeathKnight_MenuButtonPaladin:Disable();
			end

			-- CHECK TO SEE IF GoH_Priest IS INSTALLED
			_, _, _, GoH_Priest_enabled, _, _, _ = GetAddOnInfo("GoH_Priest")
			if GoH_Priest_enabled == 1 then
			-- IF GoH_Priest IS INSTALLED
				GoHv5_Settings_MenuButtonPriest:Enable();
				GoHv5_DeathKnight_MenuButtonPriest:Enable();
				if (GoH_Priest_Form:IsVisible()) then
					GoH_Priest_Form:ClearAllPoints();
					GoH_Priest_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Priest_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Priest_Form:ClearAllPoints();
				GoH_Priest_Form:Hide();
			else
			-- IF GoH_Priest IS NOT INSTALLED
				GoHv5_Settings_MenuButtonPriest:Disable();
				GoHv5_DeathKnight_MenuButtonPriest:Disable();
			end

			-- CHECK TO SEE IF GoH_Rogue IS INSTALLED
			_, _, _, GoH_Rogue_enabled, _, _, _ = GetAddOnInfo("GoH_Rogue")
			if GoH_Rogue_enabled == 1 then
			-- IF GoH_Rogue IS INSTALLED
				GoHv5_Settings_MenuButtonRogue:Enable();
				GoHv5_DeathKnight_MenuButtonRogue:Enable();
				if (GoH_Rogue_Form:IsVisible()) then
					GoH_Rogue_Form:ClearAllPoints();
					GoH_Rogue_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Rogue_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Rogue_Form:ClearAllPoints();
				GoH_Rogue_Form:Hide();
			else
			-- IF GoH_Rogue IS NOT INSTALLED
				GoHv5_Settings_MenuButtonRogue:Disable();
				GoHv5_DeathKnight_MenuButtonRogue:Disable();
			end

			-- CHECK TO SEE IF GoH_Shaman IS INSTALLED
			_, _, _, GoH_Shaman_enabled, _, _, _ = GetAddOnInfo("GoH_Shaman")
			if GoH_Shaman_enabled == 1 then
			-- IF GoH_Shaman IS INSTALLED
				GoHv5_Settings_MenuButtonShaman:Enable();
				GoHv5_DeathKnight_MenuButtonShaman:Enable();
				if (GoH_Shaman_Form:IsVisible()) then
					GoH_Shaman_Form:ClearAllPoints();
					GoH_Shaman_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Shaman_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Shaman_Form:ClearAllPoints();
				GoH_Shaman_Form:Hide();
			else
			-- IF GoH_Shaman IS NOT INSTALLED
				GoHv5_Settings_MenuButtonShaman:Disable();
				GoHv5_DeathKnight_MenuButtonShaman:Disable();
			end

			-- CHECK TO SEE IF GoH_Warlock IS INSTALLED
			_, _, _, GoH_Warlock_enabled, _, _, _ = GetAddOnInfo("GoH_Warlock")
			if GoH_Warlock_enabled == 1 then
			-- IF GoH_Warlock IS INSTALLED
				GoHv5_Settings_MenuButtonWarlock:Enable();
				GoHv5_DeathKnight_MenuButtonWarlock:Enable();
				if (GoH_Warlock_Form:IsVisible()) then
					GoH_Warlock_Form:ClearAllPoints();
					GoH_Warlock_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Warlock_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Warlock_Form:ClearAllPoints();
				GoH_Warlock_Form:Hide();
			else
			-- IF GoH_Warlock IS NOT INSTALLED
				GoHv5_Settings_MenuButtonWarlock:Disable();
				GoHv5_DeathKnight_MenuButtonWarlock:Disable();
			end

			-- CHECK TO SEE IF GoH_Warrior IS INSTALLED
			_, _, _, GoH_Warrior_enabled, _, _, _ = GetAddOnInfo("GoH_Warrior")
			if GoH_Warrior_enabled == 1 then
			-- IF GoH_Warrior IS INSTALLED
				GoHv5_Settings_MenuButtonWarrior:Enable();
				GoHv5_DeathKnight_MenuButtonWarrior:Enable();
				if (GoH_Warrior_Form:IsVisible()) then
					GoH_Warrior_Form:ClearAllPoints();
					GoH_Warrior_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Warrior_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Warrior_Form:ClearAllPoints();
				GoH_Warrior_Form:Hide();
			else
			-- IF GoH_Warrior IS NOT INSTALLED
				GoHv5_Settings_MenuButtonWarrior:Disable();
				GoHv5_DeathKnight_MenuButtonWarrior:Disable();
			end

			-- CHECK TO SEE IF GoH_Mounts IS INSTALLED
			_, _, _, GoH_Mounts_enabled, _, _, _ = GetAddOnInfo("GoH_Mounts")
			if GoH_Mounts_enabled == 1 then
			-- IF GoH_Mounts IS INSTALLED
				GoHv5_Settings_MenuButtonMounts:Show();
				GoHv5_DeathKnight_MenuButtonMounts:Show();
				GoHv5_Settings_MenuButtonMounts:Enable();
				GoHv5_DeathKnight_MenuButtonMounts:Enable();
				if (GoH_Mounts_Form:IsVisible()) then
					GoH_Mounts_Form:ClearAllPoints();
					GoH_Mounts_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Mounts_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Mounts_Form:ClearAllPoints();
				GoH_Mounts_Form:Hide();
			else
			-- IF GoH_Mounts IS NOT INSTALLED
				GoHv5_Settings_MenuButtonMounts:Disable();
				GoHv5_DeathKnight_MenuButtonMounts:Disable();
				GoHv5_Settings_MenuButtonMounts:Hide();
				GoHv5_DeathKnight_MenuButtonMounts:Hide();
			end

			-- CHECK TO SEE IF GoH_Pokemon IS INSTALLED
			_, _, _, GoH_Pokemon_enabled, _, _, _ = GetAddOnInfo("GoH_Pokemon")
			if GoH_Pokemon_enabled == 1 then
			-- IF GoH_Pokemon IS INSTALLED
				GoHv5_Settings_MenuButtonPokemon:Show();
				GoHv5_DeathKnight_MenuButtonPokemon:Show();
				GoHv5_Settings_MenuButtonPokemon:Enable();
				GoHv5_DeathKnight_MenuButtonPokemon:Enable();
				if (GoH_Pokemon_Form:IsVisible()) then
					GoH_Pokemon_Form:ClearAllPoints();
					GoH_Pokemon_Form:Hide();
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Pokemon_Form");
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_DeathKnight_Form");
				end
				GoH_Pokemon_Form:ClearAllPoints();
				GoH_Pokemon_Form:Hide();
			else
			-- IF GoH_Pokemon IS NOT INSTALLED
				GoHv5_Settings_MenuButtonPokemon:Disable();
				GoHv5_DeathKnight_MenuButtonPokemon:Disable();
				GoHv5_Settings_MenuButtonPokemon:Hide();
				GoHv5_DeathKnight_MenuButtonPokemon:Hide();
			end

		-- Show_GOH_MENU_Frame();
		GoH_Form:Show();
			end

	GoH_Settings_Set_Menu_Button_Images();

	GoH_Lose_Focus_of_EditBoxes();

end