-- #######################################
-- #######################################
-- SINCE THIS IS THE DEATH KNIGHT PART OF GOH
-- ALL GoHs CHANGED TO GoH_DeathKnight
-- #######################################
-- #######################################

-- GoH Event Registrations
	GoH_DeathKnight = {}
	GoH_DeathKnight.events = {}

	GoH_DeathKnight.eventFrame = CreateFrame("Frame");
	GoH_DeathKnight.eventFrame:SetScript("OnEvent", function(self, event, ...) GoH_DeathKnight.events[event](...) end);

	-- EVERY EVENT YOU REGISTER MUST HAVE A FUNCTION
	GoH_DeathKnight.eventFrame:RegisterEvent("ADDON_LOADED");
   	GoH_DeathKnight.eventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    GoH_DeathKnight.eventFrame:RegisterEvent("PLAYER_REGEN_DISABLED");
   	GoH_DeathKnight.eventFrame:RegisterEvent("PLAYER_REGEN_ENABLED");
    GoH_DeathKnight.eventFrame:RegisterEvent("PLAYER_LOGIN")
    GoH_DeathKnight.eventFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
    GoH_DeathKnight.eventFrame:RegisterEvent("PETITION_SHOW")
    GoH_DeathKnight.eventFrame:RegisterEvent("PARTY_INVITE_REQUEST")
    GoH_DeathKnight.eventFrame:RegisterEvent("ARENA_TEAM_INVITE_REQUEST")
    GoH_DeathKnight.eventFrame:RegisterEvent("DUEL_REQUESTED")
    GoH_DeathKnight.eventFrame:RegisterEvent("AUCTION_HOUSE_SHOW")
    GoH_DeathKnight.eventFrame:RegisterEvent("AUCTION_HOUSE_CLOSED")
    GoH_DeathKnight.eventFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
    GoH_DeathKnight.eventFrame:RegisterEvent("ADDON_ACTION_FORBIDDEN")
    GoH_DeathKnight.eventFrame:RegisterEvent("ADDON_ACTION_BLOCKED")
    GoH_DeathKnight.eventFrame:RegisterEvent("TOO_MANY_LUA_ERRORS")


-- #######################################
-- #######################################
-- INFORMATION GATHERING FOR VARIABLES LATER ON
-- #######################################
-- #######################################
	-- GENDER TABLE
	local genderTable = { "Unknown", "Male", "Female" };
	-- PLAYER CLASS
	local playerClass, EngClass = UnitClass("player");

	-- PLAYER FACTION
	local englishFaction, localizedFaction = UnitFactionGroup("player");

	-- PLAYER RACE
	local GoH_race, GoH_raceEn = UnitRace("player");

	local GoH_NoClassFormsOpen = "NO";


-- #######################################
-- #######################################
-- VARIABLES YOU CAN USE TO CHECK THINGS
-- #######################################
-- #######################################
	-- UNITNAME: CHARACTER / FACTION / CLASS / GENDER / LEVEL
	GoH_DeathKnight.CharName = UnitName("player");				-- (ToonName) Your Toon
	GoH_DeathKnight.Class = EngClass; 							-- (Class) Your Toon
	GoH_DeathKnight.Gender = genderTable[UnitSex("player")];	-- (Gender) Your Toon
	GoH_DeathKnight.Faction = englishFaction;					-- (Faction) Your Toon (Neutral,Horde, Alliance)
	GoH_DeathKnight.CharLevel = UnitLevel("player");			-- (Level) Of Your Toon
	GoH_DeathKnight.NumberRandom = 1;							-- (Random Number Generator)
	GoH_DeathKnight.Race = GoH_raceEn;							-- (Race) Of Your Toon



-- #######################################
-- #######################################
-- LOAD ADDON FUNCTION
-- #######################################
-- #######################################
function GoH_DeathKnight.events.ADDON_LOADED(addon)

	if addon ~= "GoH_DeathKnight" then
		return;
	end

	GoH_DeathKnight_Form:SetScale(0.9);
	GoH_DeathKnight_Form:SetAlpha(0.85);

	   -- IF NO SAVED VARIABLES, CALL DEFAULT VARIABLES
 	   if (not GoHv5_DeathKnight_Data) then
		-- CALL RESET
		GoH5_DeathKnight_DefaultVariables();
	   end

		-- STUPID ISSUE WITH CLASS NOT BEING LOADED/SAVED IF IN LAGVILLE
		-- THIS IS HERE TO ATTEMPT TO FORCE IT THROUGH.
		local playerClass, EngClass = UnitClass("player");
		GoH_DeathKnight.Class = EngClass;
		GoHv5_DeathKnight_Data.config.LoggedInAsClass = GoH_DeathKnight.Class;
		-- print(GoHv5_DeathKnight_Data.config.LoggedInAsClass)

		GoH_MinimapButton_Reposition();
		GoH_DeathKnight_Set_Menu_Button_Images();
		GoH_DeathKnight_Set_DeathCharger_Button_Images();
		GoH_DeathKnight_Set_Winged_Steed_Button_Images();


    -- Slash Options
    SlashCmdList["GoH_DeathKnight"] = GoH_DeathKnight.Options
        SLASH_GoH_DeathKnight1 = "/GoH_DK"
        SLASH_GoH_DeathKnight2 = "/GOH_deathknight"
        SLASH_GoH_DeathKnight3 = "/dk"
        SLASH_GoH_DeathKnight4 = "/deathknight"
        SLASH_GoH_DeathKnight5 = "/gohdk"
        SLASH_GoH_DeathKnight6 = "/gohdeathknight"
	  SlashCmdList["GoH_DeathKnight"] = GoH_DeathKnight_SlashOpenClose;

	if GoH_DeathKnight.Faction == "Horde" then
		DeathKnight_FactionPicTexture:SetTexture("interface\\AddOns\\GoH\\Images\\GoH_v5_BackGround_Faction_Horde.tga")
	elseif GoH_DeathKnight.Faction == "Alliance" then
		DeathKnight_FactionPicTexture:SetTexture("interface\\AddOns\\GoH\\Images\\GoH_v5_BackGround_Faction_Alliance.tga")
	elseif GoH_DeathKnight.Faction == "Neutral" then
		DeathKnight_FactionPicTexture:SetTexture("interface\\AddOns\\GoH\\Images\\GoH_v5_BackGround_Faction_Neutral.tga")
	end
	if GoH_DeathKnight.Gender == "Female" then
		DeathKnight_Female_Texture:Show();
	else
		DeathKnight_Female_Texture:Hide();
	end

	-- START THE TIMER
	GoHv5_Timer_Frame:Show();

	GoH5_DeathKnight_SavedVariables();

		-- SHOW / HIDE MINIMAP ICON
	    if GoHv5_DeathKnight_Data.config.Show_Minimap_Icon == "YES" then
	    	GoH_MinimapButton:Show();
	    else
	    	GoH_MinimapButton:Hide();
	    end

end

function GoH_DeathKnight_SlashOpenClose()

	if (GoH_DeathKnight_Form:IsVisible()) then

		GoH_DeathKnight_BUTTON_CLOSE_OnClick()

	else
		GoH_NoClassFormsOpen = "NO";
		GoH_CheckClassMenu_Minimap();
		if GoH_NoClassFormsOpen == "YES" then
			GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
				GoH_DeathKnight_OPEN_MENU();
			GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
		elseif GoH_NoClassFormsOpen == "NO" then
			GoH_DeathKnight_OPEN_MENU();
		end
	end
end

-- CLOSE BUTTON
function GoH_DeathKnight_BUTTON_CLOSE_OnClick()

	Play_DeathKnight_GUI_Close();
	GoH_DeathKnight_Form:Hide();

end

-- OPEN MENU
function GoH_DeathKnight_OPEN_MENU()

	if (GoH_DeathKnight_Form:IsVisible()) then
		Play_DeathKnight_GUI_Close();
	else
		GoH_NoClassFormsOpen = "NO";
		GoH_CheckClassMenu_Minimap()
		if GoH_NoClassFormsOpen == "YES" then
		else
			Play_DeathKnight_GUI_Open();
			GoH_NoClassFormsOpen = "NO";
		end
	end

	GoH_DeathKnight_Hide_and_Seek();

		-- Get the Version of the DeathKnight's Addon from the TOC file
		-- and display it on the DeathKnight's Menu near the close button.
		GoH_DeathKnight_Addon_Version = GetAddOnMetadata("GoH_DeathKnight", "Version");
		Label_GoHv5_DeathKnight_VERSION:SetText("|cFFFFD000GoH DeathKnight v"..GoH_DeathKnight_Addon_Version.."|r");

end

function GoH_Lose_Focus_of_EditBoxes()

	GoH_Check_Deathcharger_MOUNT_NAME_Text();
	GoH_Check_WingedSteed_MOUNT_NAME_Text();
	GoH_Check_Whisper_Reply_Message_Text();

	GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:ClearFocus();
	GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:EnableKeyboard(false);
	GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:ClearFocus();
	GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:EnableKeyboard(false);
	GoH5_EditBox_Whisper_Reply_Message:ClearFocus();
	GoH5_EditBox_Whisper_Reply_Message:EnableKeyboard(false);
	GoH5_EditBox_Settings_Auction_House_Reply:ClearFocus();
	GoH5_EditBox_Settings_Auction_House_Reply:EnableKeyboard(false);
	GoH5_EditBox_Settings_In_Combat_Reply:ClearFocus();
	GoH5_EditBox_Settings_In_Combat_Reply:EnableKeyboard(false);

end


function GoH_Check_Deathcharger_MOUNT_NAME_Text()
	GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_CustomName = GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:GetText();
	if GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:GetText() == "" then
		GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:SetText("Bam Bam");
		GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_CustomName = GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:GetText();
	end
end


function GoH_Check_WingedSteed_MOUNT_NAME_Text()
	GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_CustomName = GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:GetText();
	if GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:GetText() == "" then
		GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:SetText("Pebbles");
		GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_CustomName = GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:GetText();
	end
end

-- HIDE OTHER MENU FRAMES AND ALIGN THEM TO THE CORRECT USER PLACED LOCATION
function GoH_DeathKnight_Hide_and_Seek()

	GoH5_DeathKnight_SavedVariables();
	GoH_DeathKnight_Set_Menu_Button_Images();

		-- SHOW / HIDE MINIMAP ICON
		if GoHv5_DeathKnight_Data.config.Show_Minimap_Icon == nil then
			GoHv5_DeathKnight_Data.config.Show_Minimap_Icon = "YES";
		end
	    if GoHv5_DeathKnight_Data.config.Show_Minimap_Icon == "YES" then
	    	GoH_MinimapButton:Show();
	    else
	    	GoH_MinimapButton:Hide();
	    end

	-- GOH DEATHKNIGHT: Page Tab
	if GoHv5_DeathKnight_Data.config.Page_Tab == nil then
		GoHv5_DeathKnight_Data.config.Page_Tab = "ONE";
	end
	if GoHv5_DeathKnight_Data.config.Page_Tab == "TWO" then
		-- PAGE TWO
		GoH_DEATHKNIGHT_PAGE_TAB_TWO_BUTTON_ICON:Disable();
		GoH_DeathKnight_Frame:Hide();

		GoH_DEATHKNIGHT_PAGE_TAB_ONE_BUTTON_ICON:Enable();
		GoH_DeathKnight_Frame_Page2:Show();

	else
		-- PAGE ONE
		GoH_DEATHKNIGHT_PAGE_TAB_ONE_BUTTON_ICON:Disable();
		GoH_DeathKnight_Frame_Page2:Hide();

		GoH_DEATHKNIGHT_PAGE_TAB_TWO_BUTTON_ICON:Enable();
		GoH_DeathKnight_Frame:Show();

	end

	-- TURN OFF AUTO FOCUS ON EDIT BOXES
	GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:SetAutoFocus(false);
	GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:SetAutoFocus(false);

	GoH5_EditBox_DeathKnight_DeathCharger_MOUNT_NAME:SetText(GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_CustomName);
	GoH5_EditBox_DeathKnight_Winged_Steed_MOUNT_NAME:SetText(GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_CustomName);

	GoH5_EditBox_Whisper_Reply_Message:SetAutoFocus(false);
	GoH5_EditBox_Whisper_Reply_Message:SetText(GoHv5_DeathKnight_Data.config.AutoDecline_Whisper_Message);

	GoH5_EditBox_Settings_Auction_House_Reply:SetAutoFocus(false);
	GoH5_EditBox_Settings_Auction_House_Reply:SetText(GoHv5_DeathKnight_Data.config.AutoDND_Auction_House_Whisper_Message);

	GoH5_EditBox_Settings_In_Combat_Reply:SetAutoFocus(false);
	GoH5_EditBox_Settings_In_Combat_Reply:SetText(GoHv5_DeathKnight_Data.config.AutoDND_In_Combat_Whisper_Message);


	GoH_DeathKnight.Class = GoHv5_DeathKnight_Data.config.LoggedInAsClass;

	-- ###########################
	-- Disable Menu Button for Menu you are on
	-- ###########################
	GoHv5_DeathKnight_MenuButtonDeathKnight:Disable();

	-- ###########################
	-- Hide all other addon menus and show the one you want
	-- ###########################


	-- #######################################################
	-- Match all other addon menus to the Settings location
	-- #######################################################

	-- Release all points before re-assigning or we'll get a lua error
	if (GoH_Form:IsVisible()) then
		GoH_Form:ClearAllPoints();
		GoH_Form:Hide();
		GoH_DeathKnight_Form:ClearAllPoints();
		GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
		GoH_DeathKnight_Form:Show();
	else

			-- CHECK TO SEE IF GoH_Druid IS INSTALLED
			_, _, _, GoH_Druid_enabled, _, _, _ = GetAddOnInfo("GoH_Druid")
			if GoH_Druid_enabled == 1 then
			-- IF GoH_Druid IS INSTALLED
				GoHv5_Settings_MenuButtonDruid:Enable();
				GoHv5_DeathKnight_MenuButtonDruid:Enable();
				if (GoH_Druid_Form:IsVisible()) then
					GoH_Druid_Form:ClearAllPoints();
					GoH_Druid_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Druid_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Druid_Form:ClearAllPoints();
				GoH_Druid_Form:Hide();
			else
			-- IF GoH_Druid IS NOT INSTALLED
				GoHv5_Settings_MenuButtonDruid:Disable();
				GoHv5_DeathKnight_MenuButtonDruid:Disable();
			end

			-- CHECK TO SEE IF GoH_Hunter IS INSTALLED
			_, _, _, GoH_Hunter_enabled, _, _, _ = GetAddOnInfo("GoH_Hunter")
			if GoH_Hunter_enabled == 1 then
			-- IF GoH_Hunter IS INSTALLED
				GoHv5_Settings_MenuButtonHunter:Enable();
				GoHv5_DeathKnight_MenuButtonHunter:Enable();
				if (GoH_Hunter_Form:IsVisible()) then
					GoH_Hunter_Form:ClearAllPoints();
					GoH_Hunter_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Hunter_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Hunter_Form:ClearAllPoints();
				GoH_Hunter_Form:Hide();
			else
			-- IF GoH_Hunter IS NOT INSTALLED
				GoHv5_Settings_MenuButtonHunter:Disable();
				GoHv5_DeathKnight_MenuButtonHunter:Disable();
			end

			-- CHECK TO SEE IF GoH_Mage IS INSTALLED
			_, _, _, GoH_Mage_enabled, _, _, _ = GetAddOnInfo("GoH_Mage")
			if GoH_Mage_enabled == 1 then
			-- IF GoH_Mage IS INSTALLED
				GoHv5_Settings_MenuButtonMage:Enable();
				GoHv5_DeathKnight_MenuButtonMage:Enable();
				if (GoH_Mage_Form:IsVisible()) then
					GoH_Mage_Form:ClearAllPoints();
					GoH_Mage_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Mage_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Mage_Form:ClearAllPoints();
				GoH_Mage_Form:Hide();
			else
			-- IF GoH_Mage IS NOT INSTALLED
				GoHv5_Settings_MenuButtonMage:Disable();
				GoHv5_DeathKnight_MenuButtonMage:Disable();
			end

			-- CHECK TO SEE IF GoH_Monk IS INSTALLED
			_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
			if GoH_Monk_enabled == 1 then
			-- IF GoH_Monk IS INSTALLED
				GoHv5_Settings_MenuButtonMonk:Enable();
				GoHv5_DeathKnight_MenuButtonMonk:Enable();
				if (GoH_Monk_Form:IsVisible()) then
					GoH_Monk_Form:ClearAllPoints();
					GoH_Monk_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Monk_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Monk_Form:ClearAllPoints();
				GoH_Monk_Form:Hide();
			else
			-- IF GoH_Monk IS NOT INSTALLED
				GoHv5_Settings_MenuButtonMonk:Disable();
				GoHv5_DeathKnight_MenuButtonMonk:Disable();
			end

			-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
			_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
			if GoH_Paladin_enabled == 1 then
			-- IF GoH_Paladin IS INSTALLED
				GoHv5_Settings_MenuButtonPaladin:Enable();
				GoHv5_DeathKnight_MenuButtonPaladin:Enable();
				if (GoH_Paladin_Form:IsVisible()) then
					GoH_Paladin_Form:ClearAllPoints();
					GoH_Paladin_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Paladin_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Paladin_Form:ClearAllPoints();
				GoH_Paladin_Form:Hide();
			else
			-- IF GoH_Paladin IS NOT INSTALLED
				GoHv5_Settings_MenuButtonPaladin:Disable();
				GoHv5_DeathKnight_MenuButtonPaladin:Disable();
			end

			-- CHECK TO SEE IF GoH_Priest IS INSTALLED
			_, _, _, GoH_Priest_enabled, _, _, _ = GetAddOnInfo("GoH_Priest")
			if GoH_Priest_enabled == 1 then
			-- IF GoH_Priest IS INSTALLED
				GoHv5_Settings_MenuButtonPriest:Enable();
				GoHv5_DeathKnight_MenuButtonPriest:Enable();
				if (GoH_Priest_Form:IsVisible()) then
					GoH_Priest_Form:ClearAllPoints();
					GoH_Priest_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Priest_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Priest_Form:ClearAllPoints();
				GoH_Priest_Form:Hide();
			else
			-- IF GoH_Priest IS NOT INSTALLED
				GoHv5_Settings_MenuButtonPriest:Disable();
				GoHv5_DeathKnight_MenuButtonPriest:Disable();
			end

			-- CHECK TO SEE IF GoH_Rogue IS INSTALLED
			_, _, _, GoH_Rogue_enabled, _, _, _ = GetAddOnInfo("GoH_Rogue")
			if GoH_Rogue_enabled == 1 then
			-- IF GoH_Rogue IS INSTALLED
				GoHv5_Settings_MenuButtonRogue:Enable();
				GoHv5_DeathKnight_MenuButtonRogue:Enable();
				if (GoH_Rogue_Form:IsVisible()) then
					GoH_Rogue_Form:ClearAllPoints();
					GoH_Rogue_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Rogue_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Rogue_Form:ClearAllPoints();
				GoH_Rogue_Form:Hide();
			else
			-- IF GoH_Rogue IS NOT INSTALLED
				GoHv5_Settings_MenuButtonRogue:Disable();
				GoHv5_DeathKnight_MenuButtonRogue:Disable();
			end

			-- CHECK TO SEE IF GoH_Shaman IS INSTALLED
			_, _, _, GoH_Shaman_enabled, _, _, _ = GetAddOnInfo("GoH_Shaman")
			if GoH_Shaman_enabled == 1 then
			-- IF GoH_Shaman IS INSTALLED
				GoHv5_Settings_MenuButtonShaman:Enable();
				GoHv5_DeathKnight_MenuButtonShaman:Enable();
				if (GoH_Shaman_Form:IsVisible()) then
					GoH_Shaman_Form:ClearAllPoints();
					GoH_Shaman_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Shaman_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Shaman_Form:ClearAllPoints();
				GoH_Shaman_Form:Hide();
			else
			-- IF GoH_Shaman IS NOT INSTALLED
				GoHv5_Settings_MenuButtonShaman:Disable();
				GoHv5_DeathKnight_MenuButtonShaman:Disable();
			end

			-- CHECK TO SEE IF GoH_Warlock IS INSTALLED
			_, _, _, GoH_Warlock_enabled, _, _, _ = GetAddOnInfo("GoH_Warlock")
			if GoH_Warlock_enabled == 1 then
			-- IF GoH_Warlock IS INSTALLED
				GoHv5_Settings_MenuButtonWarlock:Enable();
				GoHv5_DeathKnight_MenuButtonWarlock:Enable();
				if (GoH_Warlock_Form:IsVisible()) then
					GoH_Warlock_Form:ClearAllPoints();
					GoH_Warlock_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Warlock_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Warlock_Form:ClearAllPoints();
				GoH_Warlock_Form:Hide();
			else
			-- IF GoH_Warlock IS NOT INSTALLED
				GoHv5_Settings_MenuButtonWarlock:Disable();
				GoHv5_DeathKnight_MenuButtonWarlock:Disable();
			end

			-- CHECK TO SEE IF GoH_Warrior IS INSTALLED
			_, _, _, GoH_Warrior_enabled, _, _, _ = GetAddOnInfo("GoH_Warrior")
			if GoH_Warrior_enabled == 1 then
			-- IF GoH_Warrior IS INSTALLED
				GoHv5_Settings_MenuButtonWarrior:Enable();
				GoHv5_DeathKnight_MenuButtonWarrior:Enable();
				if (GoH_Warrior_Form:IsVisible()) then
					GoH_Warrior_Form:ClearAllPoints();
					GoH_Warrior_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Warrior_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Warrior_Form:ClearAllPoints();
				GoH_Warrior_Form:Hide();
			else
			-- IF GoH_Warrior IS NOT INSTALLED
				GoHv5_Settings_MenuButtonWarrior:Disable();
				GoHv5_DeathKnight_MenuButtonWarrior:Disable();
			end

			-- CHECK TO SEE IF GoH_Mounts IS INSTALLED
			_, _, _, GoH_Mounts_enabled, _, _, _ = GetAddOnInfo("GoH_Mounts")
			if GoH_Mounts_enabled == 1 then
			-- IF GoH_Mounts IS INSTALLED
				GoHv5_Settings_MenuButtonMounts:Show();
				GoHv5_DeathKnight_MenuButtonMounts:Show();
				GoHv5_Settings_MenuButtonMounts:Enable();
				GoHv5_DeathKnight_MenuButtonMounts:Enable();
				if (GoH_Mounts_Form:IsVisible()) then
					GoH_Mounts_Form:ClearAllPoints();
					GoH_Mounts_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Mounts_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Mounts_Form:ClearAllPoints();
				GoH_Mounts_Form:Hide();
			else
			-- IF GoH_Mounts IS NOT INSTALLED
				GoHv5_Settings_MenuButtonMounts:Disable();
				GoHv5_DeathKnight_MenuButtonMounts:Disable();
				GoHv5_Settings_MenuButtonMounts:Hide();
				GoHv5_DeathKnight_MenuButtonMounts:Hide();
			end

			-- CHECK TO SEE IF GoH_Pokemon IS INSTALLED
			_, _, _, GoH_Pokemon_enabled, _, _, _ = GetAddOnInfo("GoH_Pokemon")
			if GoH_Pokemon_enabled == 1 then
			-- IF GoH_Pokemon IS INSTALLED
				GoHv5_Settings_MenuButtonPokemon:Show();
				GoHv5_DeathKnight_MenuButtonPokemon:Show();
				GoHv5_Settings_MenuButtonPokemon:Enable();
				GoHv5_DeathKnight_MenuButtonPokemon:Enable();
				if (GoH_Pokemon_Form:IsVisible()) then
					GoH_Pokemon_Form:ClearAllPoints();
					GoH_Pokemon_Form:Hide();
					GoH_Form:ClearAllPoints();
					GoH_Form:SetPoint("TOPLEFT", "GoH_Pokemon_Form");
					GoH_DeathKnight_Form:ClearAllPoints();
					GoH_DeathKnight_Form:SetPoint("TOPLEFT", "GoH_Form");
				end
				GoH_Pokemon_Form:ClearAllPoints();
				GoH_Pokemon_Form:Hide();
			else
			-- IF GoH_Pokemon IS NOT INSTALLED
				GoHv5_Settings_MenuButtonPokemon:Disable();
				GoHv5_DeathKnight_MenuButtonPokemon:Disable();
				GoHv5_Settings_MenuButtonPokemon:Hide();
				GoHv5_DeathKnight_MenuButtonPokemon:Hide();
			end

		GoH_DeathKnight_Form:Show();
	end

	GoH_Lose_Focus_of_EditBoxes();

end



-- MINIMAP OPEN CLOSE
function GoH_DeathKnight_MINIMAP_TOGGLE()

	GoH_DeathKnight.Class = GoHv5_DeathKnight_Data.config.LoggedInAsClass;

	--LEFT MOUSE BUTTON
	GoH_DeathKnight_Default_Button_Sound();
		if (GoH_Form:IsVisible()) then

			GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
			GoH_OpenClassMenu_Minimap();
			GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

		else

			GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
			GoH_NoClassFormsOpen = "NO";
			GoH_CloseClassMenu_Minimap();
			GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

			if GoH_NoClassFormsOpen == "NO" then
				GoH_OpenClassMenu_Minimap();
			end

		end

	GoH_Lose_Focus_of_EditBoxes();

end

-- MINIMAP OPEN CLOSE
function GoH_Settings_MINIMAP_TOGGLE()

	GoH_DeathKnight.Class = GoHv5_DeathKnight_Data.config.LoggedInAsClass;

	--RIGHT MOUSE BUTTON
	GoH_DeathKnight_Default_Button_Sound();
		if (GoH_Form:IsVisible()) then

			GoH_NoClassFormsOpen = "NO";
			GoH_CheckClassMenu_Minimap();
			if GoH_NoClassFormsOpen == "YES" then
				GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
					GoH_BUTTON_CLOSE_OnClick();
				GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
			elseif GoH_NoClassFormsOpen == "NO" then
				GoH_BUTTON_CLOSE_OnClick();
			end

		else

			GoH_NoClassFormsOpen = "NO";
			GoH_CheckClassMenu_Minimap();
			if GoH_NoClassFormsOpen == "YES" then
				GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
					GoH_OPEN_MENU();
				GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
			end

			if GoH_NoClassFormsOpen == "NO" then
				GoH_OPEN_MENU();
			end

		end

	GoH_Lose_Focus_of_EditBoxes();

end

function GoH_CheckClassMenu_Minimap()

	GoH_DeathKnight.Class = GoHv5_DeathKnight_Data.config.LoggedInAsClass;

			-- CHECK TO SEE IF GoH_Druid IS INSTALLED
			_, _, _, GoH_Druid_enabled, _, _, _ = GetAddOnInfo("GoH_Druid")
			if GoH_Druid_enabled == 1 then
			-- IF GoH_Druid IS INSTALLED
				if (GoH_Druid_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Hunter IS INSTALLED
			_, _, _, GoH_Hunter_enabled, _, _, _ = GetAddOnInfo("GoH_Hunter")
			if GoH_Hunter_enabled == 1 then
			-- IF GoH_Hunter IS INSTALLED
				if (GoH_Hunter_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Mage IS INSTALLED
			_, _, _, GoH_Mage_enabled, _, _, _ = GetAddOnInfo("GoH_Mage")
			if GoH_Mage_enabled == 1 then
			-- IF GoH_Mage IS INSTALLED
				if (GoH_Mage_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Monk IS INSTALLED
			_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
			if GoH_Monk_enabled == 1 then
			-- IF GoH_Monk IS INSTALLED
				if (GoH_Monk_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
			_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
			if GoH_Paladin_enabled == 1 then
			-- IF GoH_Paladin IS INSTALLED
				if (GoH_Paladin_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Priest IS INSTALLED
			_, _, _, GoH_Priest_enabled, _, _, _ = GetAddOnInfo("GoH_Priest")
			if GoH_Priest_enabled == 1 then
			-- IF GoH_Priest IS INSTALLED
				if (GoH_Priest_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Rogue IS INSTALLED
			_, _, _, GoH_Rogue_enabled, _, _, _ = GetAddOnInfo("GoH_Rogue")
			if GoH_Rogue_enabled == 1 then
			-- IF GoH_Rogue IS INSTALLED
				if (GoH_Rogue_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Shaman IS INSTALLED
			_, _, _, GoH_Shaman_enabled, _, _, _ = GetAddOnInfo("GoH_Shaman")
			if GoH_Shaman_enabled == 1 then
			-- IF GoH_Shaman IS INSTALLED
				if (GoH_Shaman_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Warlock IS INSTALLED
			_, _, _, GoH_Warlock_enabled, _, _, _ = GetAddOnInfo("GoH_Warlock")
			if GoH_Warlock_enabled == 1 then
			-- IF GoH_Warlock IS INSTALLED
				if (GoH_Warlock_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Warrior IS INSTALLED
			_, _, _, GoH_Warrior_enabled, _, _, _ = GetAddOnInfo("GoH_Warrior")
			if GoH_Warrior_enabled == 1 then
			-- IF GoH_Warrior IS INSTALLED
				if (GoH_Warrior_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Pokemon IS INSTALLED
			_, _, _, GoH_Pokemon_enabled, _, _, _ = GetAddOnInfo("GoH_Pokemon")
			if GoH_Pokemon_enabled == 1 then
			-- IF GoH_Pokemon IS INSTALLED
				if (GoH_Pokemon_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			-- CHECK TO SEE IF GoH_Mounts IS INSTALLED
			_, _, _, GoH_Mounts_enabled, _, _, _ = GetAddOnInfo("GoH_Mounts")
			if GoH_Mounts_enabled == 1 then
			-- IF GoH_Mounts IS INSTALLED
				if (GoH_Mounts_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			else
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

			if (GoH_DeathKnight.Class == "DEATHKNIGHT") then
					-- OPEN DEATH KNIGHT MENU
				if (GoH_DeathKnight_Form:IsVisible()) then
					GoH_NoClassFormsOpen = "YES";
				end
			end

	GoH_Lose_Focus_of_EditBoxes();

end

function GoH_CloseClassMenu_Minimap()

	GoH_DeathKnight.Class = GoHv5_DeathKnight_Data.config.LoggedInAsClass;

			if (GoH_DeathKnight.Class == "DRUID") then
					-- CHECK TO SEE IF GoH_Druid IS INSTALLED
					_, _, _, GoH_Druid_enabled, _, _, _ = GetAddOnInfo("GoH_Druid")
					if GoH_Druid_enabled == 1 then
					-- IF GoH_Druid IS INSTALLED
						if (GoH_Druid_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Druid_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "HUNTER") then
					-- CHECK TO SEE IF GoH_Hunter IS INSTALLED
					_, _, _, GoH_Hunter_enabled, _, _, _ = GetAddOnInfo("GoH_Hunter")
					if GoH_Hunter_enabled == 1 then
					-- IF GoH_Hunter IS INSTALLED
						if (GoH_Hunter_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Hunter_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "MAGE") then
					-- CHECK TO SEE IF GoH_Mage IS INSTALLED
					_, _, _, GoH_Mage_enabled, _, _, _ = GetAddOnInfo("GoH_Mage")
					if GoH_Mage_enabled == 1 then
					-- IF GoH_Mage IS INSTALLED
						if (GoH_Mage_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Mage_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "MONK") then
					-- CHECK TO SEE IF GoH_Monk IS INSTALLED
					_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
					if GoH_Monk_enabled == 1 then
					-- IF GoH_Monk IS INSTALLED
						if (GoH_Monk_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Monk_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "PALADIN") then
					-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
					_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
					if GoH_Paladin_enabled == 1 then
					-- IF GoH_Paladin IS INSTALLED
						if (GoH_Paladin_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Paladin_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "PRIEST") then
					-- CHECK TO SEE IF GoH_Priest IS INSTALLED
					_, _, _, GoH_Priest_enabled, _, _, _ = GetAddOnInfo("GoH_Priest")
					if GoH_Priest_enabled == 1 then
					-- IF GoH_Priest IS INSTALLED
						if (GoH_Priest_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Priest_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "ROGUE") then
					-- CHECK TO SEE IF GoH_Rogue IS INSTALLED
					_, _, _, GoH_Rogue_enabled, _, _, _ = GetAddOnInfo("GoH_Rogue")
					if GoH_Rogue_enabled == 1 then
					-- IF GoH_Rogue IS INSTALLED
						if (GoH_Rogue_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Rogue_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "SHAMAN") then
					-- CHECK TO SEE IF GoH_Shaman IS INSTALLED
					_, _, _, GoH_Shaman_enabled, _, _, _ = GetAddOnInfo("GoH_Shaman")
					if GoH_Shaman_enabled == 1 then
					-- IF GoH_Shaman IS INSTALLED
						if (GoH_Shaman_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Shaman_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "WARLOCK") then
					-- CHECK TO SEE IF GoH_Warlock IS INSTALLED
					_, _, _, GoH_Warlock_enabled, _, _, _ = GetAddOnInfo("GoH_Warlock")
					if GoH_Warlock_enabled == 1 then
					-- IF GoH_Warlock IS INSTALLED
						if (GoH_Warlock_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Warlock_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "WARRIOR") then
					-- CHECK TO SEE IF GoH_Warrior IS INSTALLED
					_, _, _, GoH_Warrior_enabled, _, _, _ = GetAddOnInfo("GoH_Warrior")
					if GoH_Warrior_enabled == 1 then
					-- IF GoH_Warrior IS INSTALLED
						if (GoH_Warrior_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_Warrior_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					else
						-- CLOSE DEFAULT DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
					end
			elseif (GoH_DeathKnight.Class == "DEATHKNIGHT") then
					-- CLOSE DEATH KNIGHT MENU
						if (GoH_DeathKnight_Form:IsVisible()) then
							GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"
							GoH_DeathKnight_BUTTON_CLOSE_OnClick();
							GoH_NoClassFormsOpen = "YES";
						end
			end

	GoH_Lose_Focus_of_EditBoxes();

end

function GoH_OpenClassMenu_Minimap()

	GoH_DeathKnight.Class = GoHv5_DeathKnight_Data.config.LoggedInAsClass;
    -- print(GoHv5_DeathKnight_Data.config.LoggedInAsClass);

    if (GoH_DeathKnight.Class == "DRUID") then
			-- CHECK TO SEE IF GoH_Druid IS INSTALLED
			_, _, _, GoH_Druid_enabled, _, _, _ = GetAddOnInfo("GoH_Druid")
			if GoH_Druid_enabled == 1 then
			-- IF GoH_Druid IS INSTALLED
				GoH_Druid_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "HUNTER") then
			-- CHECK TO SEE IF GoH_Hunter IS INSTALLED
			_, _, _, GoH_Hunter_enabled, _, _, _ = GetAddOnInfo("GoH_Hunter")
			if GoH_Hunter_enabled == 1 then
			-- IF GoH_Hunter IS INSTALLED
				GoH_Hunter_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "MAGE") then
			-- CHECK TO SEE IF GoH_Mage IS INSTALLED
			_, _, _, GoH_Mage_enabled, _, _, _ = GetAddOnInfo("GoH_Mage")
			if GoH_Mage_enabled == 1 then
			-- IF GoH_Mage IS INSTALLED
				GoH_Mage_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "MONK") then
			-- CHECK TO SEE IF GoH_Monk IS INSTALLED
			_, _, _, GoH_Monk_enabled, _, _, _ = GetAddOnInfo("GoH_Monk")
			if GoH_Monk_enabled == 1 then
			-- IF GoH_Monk IS INSTALLED
				GoH_Monk_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "PALADIN") then
			-- CHECK TO SEE IF GoH_Paladin IS INSTALLED
			_, _, _, GoH_Paladin_enabled, _, _, _ = GetAddOnInfo("GoH_Paladin")
			if GoH_Paladin_enabled == 1 then
			-- IF GoH_Paladin IS INSTALLED
				GoH_Paladin_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "PRIEST") then
			-- CHECK TO SEE IF GoH_Priest IS INSTALLED
			_, _, _, GoH_Priest_enabled, _, _, _ = GetAddOnInfo("GoH_Priest")
			if GoH_Priest_enabled == 1 then
			-- IF GoH_Priest IS INSTALLED
				GoH_Priest_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "ROGUE") then
			-- CHECK TO SEE IF GoH_Rogue IS INSTALLED
			_, _, _, GoH_Rogue_enabled, _, _, _ = GetAddOnInfo("GoH_Rogue")
			if GoH_Rogue_enabled == 1 then
			-- IF GoH_Rogue IS INSTALLED
				GoH_Rogue_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "SHAMAN") then
			-- CHECK TO SEE IF GoH_Shaman IS INSTALLED
			_, _, _, GoH_Shaman_enabled, _, _, _ = GetAddOnInfo("GoH_Shaman")
			if GoH_Shaman_enabled == 1 then
			-- IF GoH_Shaman IS INSTALLED
				GoH_Shaman_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "WARLOCK") then
			-- CHECK TO SEE IF GoH_Warlock IS INSTALLED
			_, _, _, GoH_Warlock_enabled, _, _, _ = GetAddOnInfo("GoH_Warlock")
			if GoH_Warlock_enabled == 1 then
			-- IF GoH_Warlock IS INSTALLED
				GoH_Warlock_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "WARRIOR") then
			-- CHECK TO SEE IF GoH_Warrior IS INSTALLED
			_, _, _, GoH_Warrior_enabled, _, _, _ = GetAddOnInfo("GoH_Warrior")
			if GoH_Warrior_enabled == 1 then
			-- IF GoH_Warrior IS INSTALLED
				GoH_Warrior_OPEN_MENU();
			else
				-- OPEN DEATH KNIGHT MENU
				GoH_DeathKnight_OPEN_MENU();
			end
	elseif (GoH_DeathKnight.Class == "DEATHKNIGHT") then
			-- OPEN DEATH KNIGHT MENU
			GoH_DeathKnight_OPEN_MENU();
	end

	GoH_Lose_Focus_of_EditBoxes();

end


-- ###################################
-- ###################################
-- CLASS MENU AND SETTINGS BUTTON AREA
-- ###################################
-- ###################################
function GoHv5_DeathKnight_MenuButtonPokemon_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Pokemon_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonMounts_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Mounts_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonWarrior_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Warrior_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonWarlock_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Warlock_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonShaman_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Shaman_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonRogue_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Rogue_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonPriest_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Priest_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonPaladin_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Paladin_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonMonk_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Monk_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonMage_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Mage_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonHunter_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Hunter_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonDruid_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_Druid_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonSettings_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end

function GoHv5_DeathKnight_MenuButtonDeathKnight_OnClick()

		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "YES"
		GoH_DeathKnight_OPEN_MENU();
		GoHv5_DeathKnight_Data.config.GoH_MenuOpenedAlready = "NO"

end


-- #######################################
-- #######################################
-- Call this in a mod's initialization to move the minimap button to its saved position (also used in its movement)
function GoH_MinimapButton_Reposition()
	GoH_MinimapButton:SetPoint("TOPLEFT","Minimap","TOPLEFT",52-(80*cos(GoH_MinimapIcon.GoH_MinimapPos)),(80*sin(GoH_MinimapIcon.GoH_MinimapPos))-52)

end

-- Only while the button is dragged this is called every frame
function GoH_MinimapButton_DraggingFrame_OnUpdate()

	local xpos,ypos = GetCursorPosition()
	local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom()

	xpos = xmin-xpos/UIParent:GetScale()+70 -- get coordinates as differences from the center of the minimap
	ypos = ypos/UIParent:GetScale()-ymin-70

	GoH_MinimapIcon.GoH_MinimapPos = math.deg(math.atan2(ypos,xpos)) -- save the degrees we are relative to the minimap center
	GoH_MinimapButton_Reposition() -- move the button
end

function GoH_MinimapButton_OnEnter(self)
	if (self.dragging) then
		return
	end
	GameTooltip:SetOwner(self or UIParent, "ANCHOR_LEFT")
	GoH_MinimapButton_Details(GameTooltip)
end


function GoH_MinimapButton_Details(tt, ldb)
	tt:SetText("Get Over Here!")

end

